org.apache.ignite.internal.processors.cache.persistence

## Class GridCacheOffheapManager

- java.lang.Object
- - org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl
  - - org.apache.ignite.internal.processors.cache.persistence.GridCacheOffheapManager

All Implemented Interfaces:
  IgniteCacheOffheapManager, DbCheckpointListener

    public class GridCacheOffheapManager
    extends IgniteCacheOffheapManagerImpl
    implements DbCheckpointListener

Used when persistence enabled.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl

`IgniteCacheOffheapManagerImpl.CacheDataRowStore, IgniteCacheOffheapManagerImpl.CacheDataStoreImpl, IgniteCacheOffheapManagerImpl.CacheDataTree, IgniteCacheOffheapManagerImpl.CacheIdAwareDataInnerIO, IgniteCacheOffheapManagerImpl.CacheIdAwareDataLeafIO, IgniteCacheOffheapManagerImpl.CacheIdAwarePendingEntryInnerIO, IgniteCacheOffheapManagerImpl.CacheIdAwarePendingEntryLeafIO, IgniteCacheOffheapManagerImpl.DataInnerIO, IgniteCacheOffheapManagerImpl.DataLeafIO, IgniteCacheOffheapManagerImpl.PendingEntriesTree, IgniteCacheOffheapManagerImpl.PendingEntryInnerIO, IgniteCacheOffheapManagerImpl.PendingEntryLeafIO`

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.processors.cache.persistence.DbCheckpointListener

`DbCheckpointListener.Context`

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManager

`IgniteCacheOffheapManager.CacheDataStore, IgniteCacheOffheapManager.OffheapInvokeClosure`

### Field Summary

### Fields inherited from class org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl

`ctx, grp, log, partDataStores, pendingEntries`

### Constructor Summary

Constructors
Constructor and Description
`GridCacheOffheapManager()`

### Method Summary

Methods
`protected IgniteCacheOffheapManager.CacheDataStore` `createCacheDataStore0(int p)`
`protected void` `destroyCacheDataStore0(IgniteCacheOffheapManager.CacheDataStore store)`
`void` `dropRootPageForIndex(int cacheId, String idxName)`
`protected void` `initDataStructures()`
`long` `lastUpdatedPartitionCounter(int part)` Partition counter provider.
`void` `onCacheStarted(GridCacheContext cctx)`
`void` `onCheckpointBegin(DbCheckpointListener.Context ctx)`
`void` `onPartitionCounterUpdated(int part, long cntr)` Partition counter update callback.
`void` `onPartitionInitialCounterUpdated(int part, long cntr)` Initial counter will be updated on state restore only
`IgniteRebalanceIterator` `rebalanceIterator(int part, AffinityTopologyVersion topVer, Long partCntrSince)`
`ReuseList` `reuseListForIndex(String idxName)`
`RootPage` `rootPageForIndex(int cacheId, String idxName)`
`void` `stop()`

### Methods inherited from class org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl

`cacheDataStores, cacheEntriesCount, cacheEntriesCount, cacheEntriesCount, cacheEntriesIterator, cacheIterator, cacheKeysIterator, cachePartitionIterator, clearCache, containsKey, createCacheDataStore, dataStore, destroyCacheDataStore, expire, expiredSize, globalRemoveId, invoke, offHeapAllocatedSize, onKernalStop, onUndeploy, partitionIterator, read, read, remove, start, stopCache, totalPartitionEntriesCount, treeName, update, updateIndexes`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### GridCacheOffheapManager

    public GridCacheOffheapManager()

### Method Detail

#### initDataStructures

    protected void initDataStructures()
                               throws IgniteCheckedException

Overrides:
  `initDataStructures` in class `IgniteCacheOffheapManagerImpl`
Throws:
  `IgniteCheckedException` - If failed.

#### onCacheStarted

    public void onCacheStarted(GridCacheContext cctx)
                        throws IgniteCheckedException

Specified by:
  `onCacheStarted` in interface `IgniteCacheOffheapManager`
Overrides:
  `onCacheStarted` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `cctx` - Cache context.
Throws:
  `IgniteCheckedException` - If failed.

#### createCacheDataStore0

    protected IgniteCacheOffheapManager.CacheDataStore createCacheDataStore0(int p)
                                                                      throws IgniteCheckedException

Overrides:
  `createCacheDataStore0` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `p` - Partition.
Returns:
  Cache data store.
Throws:
  `IgniteCheckedException` - If failed.

#### onCheckpointBegin

    public void onCheckpointBegin(DbCheckpointListener.Context ctx)
                           throws IgniteCheckedException

Specified by:
  `onCheckpointBegin` in interface `DbCheckpointListener`
Throws:
  `IgniteCheckedException` - If failed.

#### destroyCacheDataStore0

    protected void destroyCacheDataStore0(IgniteCacheOffheapManager.CacheDataStore store)
                                   throws IgniteCheckedException

Overrides:
  `destroyCacheDataStore0` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `store` - Cache data store.
Throws:
  `IgniteCheckedException` - If failed.

#### onPartitionCounterUpdated

    public void onPartitionCounterUpdated(int part,
                                 long cntr)

Partition counter update callback. May be overridden by plugin-provided subclasses.

Specified by:
  `onPartitionCounterUpdated` in interface `IgniteCacheOffheapManager`
Overrides:
  `onPartitionCounterUpdated` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `part` - Partition.
  `cntr` - Partition counter.

#### onPartitionInitialCounterUpdated

    public void onPartitionInitialCounterUpdated(int part,
                                        long cntr)

Initial counter will be updated on state restore only

Specified by:
  `onPartitionInitialCounterUpdated` in interface `IgniteCacheOffheapManager`
Overrides:
  `onPartitionInitialCounterUpdated` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `part` - Partition
  `cntr` - New initial counter

#### lastUpdatedPartitionCounter

    public long lastUpdatedPartitionCounter(int part)

Partition counter provider. May be overridden by plugin-provided subclasses.

Specified by:
  `lastUpdatedPartitionCounter` in interface `IgniteCacheOffheapManager`
Overrides:
  `lastUpdatedPartitionCounter` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `part` - Partition ID.
Returns:
  Last updated counter.

#### rootPageForIndex

    public RootPage rootPageForIndex(int cacheId,
                            String idxName)
                              throws IgniteCheckedException

Specified by:
  `rootPageForIndex` in interface `IgniteCacheOffheapManager`
Overrides:
  `rootPageForIndex` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `cacheId` - Cache ID.
  `idxName` - Index name.
Returns:
  Root page for index tree.
Throws:
  `IgniteCheckedException` - If failed.

#### dropRootPageForIndex

    public void dropRootPageForIndex(int cacheId,
                            String idxName)
                              throws IgniteCheckedException

Specified by:
  `dropRootPageForIndex` in interface `IgniteCacheOffheapManager`
Overrides:
  `dropRootPageForIndex` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `cacheId` - Cache ID.
  `idxName` - Index name.
Throws:
  `IgniteCheckedException` - If failed.

#### reuseListForIndex

    public ReuseList reuseListForIndex(String idxName)

Specified by:
  `reuseListForIndex` in interface `IgniteCacheOffheapManager`
Overrides:
  `reuseListForIndex` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `idxName` - Index name.
Returns:
  Reuse list for index tree.

#### stop

    public void stop()

Specified by:
  `stop` in interface `IgniteCacheOffheapManager`
Overrides:
  `stop` in class `IgniteCacheOffheapManagerImpl`

#### rebalanceIterator

    public IgniteRebalanceIterator rebalanceIterator(int part,
                                            AffinityTopologyVersion topVer,
                                            Long partCntrSince)
                                              throws IgniteCheckedException

Specified by:
  `rebalanceIterator` in interface `IgniteCacheOffheapManager`
Overrides:
  `rebalanceIterator` in class `IgniteCacheOffheapManagerImpl`
Parameters:
  `part` - Partition.
  `topVer` - Topology version.
  `partCntrSince` - Partition counter to get historical data if available.
Returns:
  Partition data iterator.
Throws:
  `IgniteCheckedException` - If failed.

2017 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 2.1.0
Release Date | : July 20 2017